from libdesklets.controls import Control

from ICalendar import ICalendar

import calendar

class Calendar(Control, ICalendar):


    __DAYS = (_('Monday'), _('Tuesday'), _('Wednesday'), _('Thursday'),
              _('Friday'), _('Saturday'), _('Sunday'))

    __MONTHS = (_('January'), _('February'), _('March'), _('April'),
                _('May'), _('June'), _('July'), _('August'), _('September'),
                _('October'), _('November'), _('December'))


    def __init__(self):
        self.__time = Null
        Control.__init__(self)


    def __get_days(self):
        return self.__DAYS


    def __get_months(self):
        return self.__MONTHS


    def __set_time(self, time):

        assert 'ITime:9y703dqtfnv4w373caserz68r' in time.get_interfaces_id()
        self.__time = time


    def __ymd(self):
        return self.__time.date
    

    def __get_day(self):
        wd = calendar.weekday( *self.__ymd() )
        return self.__DAYS[ wd ]


    def __get_month(self):
        return self.__MONTHS[ self.__ymd()[1] - 1 ]



    day    = property(fget = __get_day)
    days   = property(fget = __get_days)
    month  = property(fget = __get_month)
    months = property(fget = __get_months)
    time   = property(fset = __set_time)


def get_class(): return Calendar
