from Device import Device
from utils.Struct import Struct

import threading
import time

class Swap(Device):

    def __init__(self):

        Device.__init__(self)

        self.__swap = Struct( pagein  = 0,
                              pageout = 0,
                              time    = time.time(),
                              lock    = threading.Lock()
                              )


    def poll(self):

        self.__swap.lock.acquire()

        try:
            swap = libgtop.swap()

            now       = time.time()
            page_in   = swap.pagein
            page_out  = swap.pageout

            time_diff = now - self.__swap.time
            in_diff   = pagein  - self.__swap.pagein
            out_diff  = pageout - self.__swap.pageout

            speed_in  = int(in_diff / time_diff)
            speed_out = int(out_diff / time_diff)

            self.__swap.update(swap)
            self.__swap.time = now

            return (speed_in, speed_out)

        finally:
            self.__swap.lock.release()

