from plugin.PluginRegistry import PluginRegistry
from plugin.Interface import Interface
from PluginWrapper import PluginWrapper
from main import HOME, USERHOME

import os


#
# Registry for shell plugins.
#
class _PluginRegistry:

    def __init__(self):

        # table: class -> wrapped
        self.__cache = {}
        
        # table: query -> result
        self.__query_cache = {}

        path = os.path.dirname(__file__)
        self.__registry = PluginRegistry(os.path.join(path, "plugins"))



    def get_plugins_by_pattern(self, key, pattern):

        query = "(MATCH '%s' '%s')" % (key, pattern)
        if (not query in self.__query_cache):
            result = self.__registry.get_plugins(query)
            self.__query_cache[query] = result[:]
        else:
            result = self.__query_cache[query]

        ret = []
        for clss in result:
            if (clss in self.__cache):
                ret.append(self.__cache[clss])
            else:
                methods = []
                for iface in Interface.get_interfaces(clss):
                    methods += dir(iface)
                plugin = clss()
                wrapped = PluginWrapper(plugin, methods)
                self.__cache[clss] = wrapped
                plugin.init()
                ret.append(wrapped)
        #end for

        return ret


    #
    # Returns a control providing the given interfaces.
    #
    def get_plugin(self, name, *interfaces):

        result = self.get_plugins_by_pattern("name", name)
        if (result):
            return result[0]
        else:
            return
    
        query = "(MATCH 'name' '%s')" % (name)
        result = self.__registry.get_plugins(query)

        if (result):
            clss = result[0]
            if (clss in self.__cache):
                return self.__cache[clss]
            
            else:
                methods = []
                for iface in Interface.get_interfaces(clss):
                    methods += dir(iface)
                plugin = clss()
                wrapped = PluginWrapper(plugin, methods)
                self.__cache[clss] = wrapped
                plugin.init()
                return wrapped
            
        else:
            return

        #end if


# singleton object
registry = _PluginRegistry()
