from plugin.Interface import Interface
import gtk


#
# Dialog for inspecting controls.
#
class ControlInspector(gtk.Dialog):

    def __init__(self, ctrlclass):

        gtk.Dialog.__init__(self, buttons = (gtk.STOCK_CLOSE,
                                             gtk.RESPONSE_CLOSE))
        self.set_default_size(400, 200)
        self.connect("response", self.__on_close)

        vbox = self.vbox

        name = ctrlclass.__name__
        self.set_title(_("%s Control") % (name))
        #lbl = gtk.Label("<b>" + name + "</b>")
        #lbl.set_use_markup(True)
        #vbox.pack_start(lbl, False, False)

        scrwin = gtk.ScrolledWindow()
        scrwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
        vbox.pack_end(scrwin, True, True)

        box = gtk.VBox()
        scrwin.add_with_viewport(box)

        # list the interfaces and their descriptions
        texts = Interface.describe(ctrlclass, True, True)

        for cnt, text in enumerate(texts):
            
            lbl = gtk.Label(text)
            lbl.set_use_markup(True)
            lbl.set_selectable(True)
            box.pack_start(lbl, False, False)

            # don't put a separator after the last entry
            if (cnt < len(texts) - 1):
                sep = gtk.HSeparator()
                box.pack_start(sep, False, False)
        #end for
        
        vbox.show_all()


    def __on_close(self, src, response):

        self.destroy()
