#
# Module for turning classes into singletons.
#
# Usage:
#   from utils import singleton
#   object1 = singleton.get(clss)
#   object2 = singleton.get(clss)
#
# object1 and object2 point to the same object.
#

# TODO
# check if it is used in a MT context
#  -> add locking


_singletons = {}


def get(clss, *args):

    if clss not in _singletons:
        _singletons[clss] = clss(*args)

    # would have been better but calling call is expensive ...
    # return _singletons.setdefault(clss, clss(*args))
    return _singletons[clss]
